## --cc @ 2013-04-29
# mod to parse all thin and thick prov volumes 
# for efficiency, output to screen only
## --cc @ 2013-09-04; remodified script as per previous intermediar version to go through snapshots and replicasets as well.
#

f_getstarted()
{
    curdir=`pwd`;
   	if [ -e /mgtdb/update ]; then
		cd /mgtdb/update
	else 
		if [ !-d /mgtdb/update ]; then
			echo "ERROR: Unable to change to correct path"
			return 1
		fi
	fi
	echo "Executing $(echo $0) in ${curdir}";
    return 0
}
f_getout(){
    if [ $# -eq 0 ]; then
        exitStatus=0 ## error
        echo "got terminated with errors or interrupted... ending script execution here"
	exit $1
     else
        exitStatus=1 ## Success
		echo "Exiting ..."
	 exit $1
    fi
}
f_getmem(){
member=`hostname`
if [ -z "${member}" ]; then
	echo "ERROR: unable to read member name."
	return 0
	else 
	echo "${member}"
fi
}


### Let's run it ###

trap f_getout 1 2 3 4 5 9

echo Running script ...
f_getstarted
if [ $? -ne 0 ]; then
	echo "Exiting with a status of 1"
	f_getout 0
fi

if [ `f_getmem` != `hostname` ]; then
	echo "Cannot understand hostname; Exiting ..."
	return 0
	f_getout 0
	else
	echo -e "\nRunning script [ $(echo $0) ] on: `hostname` \n\tPlease capture the console output"
fi

# gather specific volumes lost blocks data 
echo -e "\n\n=----=\n"
echo "Parsing all volumes (thick/thin/Replica/snapshots) for lost cache blocks ..."
echo "Output of pm vol on snapshots should be disregarded."
echo -e "\n\n::: =------------= :::"
for vol in `iom ls -as | awk '/^[BSR]/{gsub(/t /,""); print $2}'`; \
	do echo -e "\n\n...........................\nVolume\t::\t $vol"; \
	pm vol $vol; \
	iom check_lost_blocks $vol; \
	done

echo -e "\n=------------ DONE ----------------=\n"

f_getout 1